package com.seeyon.apps.collaoration.api;

import java.io.File;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.seeyon.apps.collaboration.enums.CollaborationEnum;
import com.seeyon.apps.collaboration.manager.ColManager;
import com.seeyon.apps.collaboration.po.ColSummary;
import com.seeyon.apps.http.SeeyonTestRequest;
import com.seeyon.apps.http.SeeyonTestResponse;
import com.seeyon.apps.utils.ControllerFactory;
import com.seeyon.apps.utils.SeeyonTestUtil;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.GlobalNames;
import com.seeyon.ctp.common.affair.manager.AffairManager;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.constants.ApplicationCategoryEnum;
import com.seeyon.ctp.common.constants.ApplicationSubCategoryEnum;
import com.seeyon.ctp.common.content.affair.constants.StateEnum;
import com.seeyon.ctp.common.content.affair.constants.SubStateEnum;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.po.affair.CtpAffair;
import com.seeyon.ctp.common.po.template.CtpTemplate;
import com.seeyon.ctp.common.template.controller.CollaborationTemplateController;
import com.seeyon.ctp.common.template.manager.TemplateManager;
import com.seeyon.ctp.organization.bo.V3xOrgAccount;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.util.DBAgent;
import com.seeyon.ctp.util.json.JSONUtil;

public class ColApiImplDataInit {
	
	protected static V3xOrgMember  tanmf                          = new V3xOrgMember();
	protected static V3xOrgMember  seeyon                         = new V3xOrgMember();
    protected static V3xOrgAccount group                          = new V3xOrgAccount();
    protected static V3xOrgMember  groupAdmin                     = new V3xOrgMember();
    protected static V3xOrgAccount account                        = new V3xOrgAccount();
    protected static V3xOrgMember  accountAdmin                   = new V3xOrgMember();
    
    protected static Long formRecordId = 20001L;

    protected static Long templatesId3 = 3L;
    protected static Long templatesId4 = 4L;
    
    protected static Long summaryId1 = 1L;
    protected static Long summaryId2 = 2L;
    protected static Long summaryId3 = 3L;
    protected static Long summaryId4 = 4L;
    
    protected static String processId91 = "91";
    protected static String processId92 = "92";
    protected static String processId93 = "93";
    protected static String processId94 = "94";
    
    
    protected static Long summaryId5 = 990012L;
    protected static Long summaryId6 = 6L;
    protected static Long summaryId7 = 7L;
    
    protected static List<Long> summaryIds = new ArrayList<Long>();
    protected static List<ColSummary> summaryList = new ArrayList<ColSummary>();
    
    protected static List<Long> templatesId = new ArrayList<Long>();
    
    
    protected static List<CtpAffair> affairPendingList = new ArrayList<CtpAffair>();
    

	static OrgManager orgManager = (OrgManager) AppContext.getBean("orgManager");
	static ColManager colManager = (ColManager) AppContext.getBean("colManager");
	
	static TemplateManager templateManager = (TemplateManager)AppContext.getBean("templateManager");
    
    
    /**
     * 初始化数据，创建一些协同数据
     * <pre>
     * 
     * 4条协同数据（Col_Summary），3条协同对应3个事项（已发，已办，待办分别一条），剩下的一条数据是草稿状态。
     * 其中自由协同2条，协同模板数据1条，表单模板数据1条，人员均为tanmf
     * 
     * 自由协同1: summary{id:1 ; subject:'自由协同1';processId:-1}<br>
     *                   affair（待发）：{id:11 ; object_id:1 ; state:1}
     *                   
     * 自由协同2: summary{id:2 ; subject:'自由协同2';processId:90}<br>
     *                   affair（已发）：{id:22 ; object_id:2 ; state:2;processId:90}
     *                   affair（待办）：{id:23 ; object_id:2 ; state:3;processId:90}
     *                   affair（已办）：{id:24 ; object_id:2 ; state:4;processId:90}
     * 模板协同3: summary{id:3 ; subject:'模板协同3';processId:91}<br>
     *                   affair（已发）：{id:32 ; object_id:3 ; state:2 ; template_id:templateId3;processId:91}
     *                   affair（待办）：{id:33 ; object_id:3 ; state:3 ; template_id:templateId3;processId:91}
     *                   affair（已办）：{id:34 ; object_id:3 ; state:4 ; template_id:templateId3;processId:91}
     * 表单协同4: summary{id:4 ; subject:'表单协同4';processId:92}<br>
     *                   affair（已发）：{id:42 ; object_id:4 ; state:2 ; form_record_id:formRecordId ; template_id:templateId4;processId:92}
     *                   affair（待办）：{id:43 ; object_id:4 ; state:3 ; form_record_id:formRecordId ; template_id:templateId4;processId:92}
     *                   affair（已办）：{id:44 ; object_id:4 ; state:4 ; form_record_id:formRecordId ; template_id:templateId4;processId:92}
     *                   
     * </pre>
     * @param initdb 是否初始化数据库
     * @throws BusinessException
     */
    public static void initCollaborationData(boolean initdb) throws BusinessException {
    /*	DELETE from ctp_affair;
		DELETE from col_summary;
		delete from ctp_comment_all;
		DELETE FROM ctp_template
		
		select * from col_summary;
		select * from ctp_affair;
		SELECT * FROM ctp_template*/
        
        clearData();

        tanmf = orgManager.getMemberByLoginName("tanmf");
        
        summaryIds.add(summaryId1);
        summaryIds.add(summaryId2);
        summaryIds.add(summaryId3);
        summaryIds.add(summaryId4);
        templatesId.add(templatesId3);
        templatesId.add(templatesId4);
        if (initdb) {
        	
        	saveColSummary(colManager,"自由协同1","10",1,null,null,processId91);
        	
        	saveColSummary(colManager,"自由协同2","10",2,null,null, processId92);
        	
        	saveColSummary(colManager,"模板协同3","10",3,templatesId3,null, processId93);
        	
        	saveColSummary(colManager,"表单协同4","20",4,templatesId4,formRecordId, processId94);
        	
        	try {
				saveTemplate();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        }
    }
    
    private static void clearData(){
        
        Map<String,Object> param = new HashMap<String,Object>();
        String delAffs = "delete from CtpAffair ";
        DBAgent.bulkUpdate(delAffs, param);
        
        String delSummarys = "delete from ColSummary ";
        DBAgent.bulkUpdate(delSummarys, param);
        
        String delTemplates = "delete from CtpTemplate ";
        DBAgent.bulkUpdate(delTemplates, param);
        
        String delComments = "delete from CtpCommentAll ";
        DBAgent.bulkUpdate(delComments, param);
        
        DBAgent.commit();
    }
    /**
     * 
     * 为根据ID查询ColSummary提供数据
     * @param colManager
     * @throws BusinessException
     */
    public static void saveColSummary(ColManager colManager,String subject,String bodyType,long summaryId,Long _templateId,Long _fromRecordId,String processId) throws BusinessException {
    	
    	AffairManager affairManager = (AffairManager)AppContext.getBean("affairManager");
    	
    	//清楚数据
    	affairManager.deletePhysicalByObjectId(summaryId);
    	colManager.deleteColSummaryUseHqlById(summaryId);
    	DBAgent.commit();
    	
    	ColSummary s = saveSummaryData(colManager, subject,bodyType,summaryId, _templateId, _fromRecordId, processId);
    	
    	
		if(summaryId == 1){
			
			addAffairData(11l,affairManager, s, StateEnum.col_waitSend, processId);
			
		} else {
			if(summaryId == summaryId2){
				addAffairData(22l,affairManager,s,StateEnum.col_sent, processId);
		    	
		    	addAffairData(24l,affairManager,s,StateEnum.col_done, processId);
		    	
		    	addAffairData(23l,affairManager,s,StateEnum.col_pending, processId);
			}
			else if(summaryId == summaryId3){
				addAffairData(32l,affairManager,s,StateEnum.col_sent, processId);
		    	
		    	addAffairData(34l,affairManager,s,StateEnum.col_done, processId);
		    	
		    	addAffairData(33l,affairManager,s,StateEnum.col_pending, processId);
			}
			else if(summaryId == summaryId4){
				addAffairData(42l,affairManager,s,StateEnum.col_sent, processId);
		    	
		    	addAffairData(44l,affairManager,s,StateEnum.col_done, processId);
		    	
		    	addAffairData(43l,affairManager,s,StateEnum.col_pending, processId);
			}
			
		}
		
	}

	private static ColSummary saveSummaryData(ColManager colManager, String subject,String bodyType, long id, Long _templateId,Long _fromRecordId,String processId) throws BusinessException {
		ColSummary summary = new ColSummary();
    	summary.setId(id);
		summary.setSubject(subject);//标题
        summary.setDeadline(null);
        summary.setDeadlineDatetime(null);
        summary.setAdvanceRemind(null);
        summary.setAwakeDate(null);
        summary.setImportantLevel(1);
        summary.setArchiveId(null);
        summary.setAdvancePigeonhole(null);
        summary.setProjectId(null);
        summary.setCanArchive(true);
        summary.setCanAutostopflow(false);
        summary.setCanEdit(true);
        summary.setCanEditAttachment(true);
        summary.setCanModify(true);
        summary.setCanForward(true);
        summary.setFormAppid(null);//表单ID
        if ("20".equals(bodyType)) {
        	summary.setFormRecordid(_fromRecordId);//form主数据ID
        }
        Timestamp now = new Timestamp(System.currentTimeMillis());
        summary.setCreateDate(now);
        summary.setState(null);
        summary.setStartMemberId(tanmf.getId());
        summary.setBodyType(bodyType);//设置正文类型
        summary.setOrgAccountId(group.getId());
        summary.setTempleteId(_templateId);
        summary.setAudited(false);
        summary.setVouch(CollaborationEnum.vouchState.defaultValue.ordinal());
        summary.setProcessId(processId);
        summary.setCaseId(null);
        summary.setStartDate(null);
		colManager.saveColSummary(summary);
		return summary;
	}
        
  
    public static void addAffairData(Long id,AffairManager affairManager,ColSummary summary,StateEnum state,String processId) throws BusinessException{
    	Date now =  new Date();
        CtpAffair  affair = new CtpAffair();
        affair.setCreateDate(now);
        affair.setId(id);
        affair.setApp(ApplicationCategoryEnum.collaboration.key());
        affair.setSubApp(summary.getTempleteId() == null ? ApplicationSubCategoryEnum.collaboration_self.key():ApplicationSubCategoryEnum.collaboration_tempate.key());
        affair.setSubject("测试协同1");
        affair.setReceiveTime(now);
        affair.setUpdateDate(now);
        affair.setMemberId(tanmf.getId());
        affair.setObjectId(summary.getId());
        affair.setSubObjectId(null);
        affair.setSenderId(tanmf.getId());
        affair.setState(state.key()); 
        affair.setSubState(SubStateEnum.col_normal.key());
        affair.setTempleteId(summary.getTempleteId());
        affair.setBodyType(summary.getBodyType());
        affair.setImportantLevel(summary.getImportantLevel());
        affair.setResentTime(summary.getResentTime());
        affair.setForwardMember(summary.getForwardMember());
        affair.setExpectedProcessTime(now);
        affair.setDeadlineDate(0L);
        affair.setNodePolicy("collaboration");//协同发起人节点权限默认为协同
        affair.setTrack(1);
        affair.setDelete(false);
        affair.setFinish(false);
        affair.setCoverTime(false);
        affair.setHasFavorite(true);
        affair.setDueRemind(false);
        affair.setArchiveId(null);
        affair.setFormAppId(summary.getFormAppid());
        affair.setProcessId(processId);
        affair.setSummaryState(summary.getState());
        affairManager.save(affair);
    }
    
    //全局的常量
    /*在ctp-test初始化的时候加载的*/
    public final static String TEST_HOME = System.getProperty("TEST_HOME");
    
    public final static String testResponseFolder = TEST_HOME + "/home/tomcat/webapp/logs/";
    
    /*模拟response的输出流，让流直接操作文件*/
    public final static String testResponseFile = testResponseFolder + "collaboraction.txt";
    
    private static ControllerFactory factory = ControllerFactory.getInstance();
    
    protected static Long templatesId5 = 5L;
    
    
    
    public static SeeyonTestResponse setTransDoForwardJsonParamsToQuest() throws BusinessException{

    
    	
    	 String rParams = "_json_params={" + 
    	 		"\"workflow_definition\":{" + 
    	 		"\"process_desc_by\":\"xml\"," + 
    	 		"\"process_xml\":\"<ps><p s=\\\"\\\" u=\\\"\\\" y=\\\"0\\\" x=\\\"0\\\" i=\\\"\\\" n=\\\"\\\" d=\\\"\\\" t=\\\"\\\"><n m=\\\"0\\\" y=\\\"\\\" x=\\\"\\\" t=\\\"8\\\" d=\\\"\\\" n=\\\"\\\" i=\\\"start\\\"><a a=\\\"\\\" b=\\\"\\\" c=\\\"1\\\" d=\\\"\\\" e=\\\"\\\" f=\\\"\\\" g=\\\"\\\" i=\\\"false\\\" j=\\\"false\\\" k=\\\"\\\"/><s c=\\\"1\\\" r=\\\"\\\" e=\\\"\\\" f=\\\"\\\" g=\\\"0\\\" j=\\\"multiple\\\" k=\\\"\\\" l=\\\"\\\" m=\\\"false\\\" s=\\\"success\\\" d=\\\"\\\" t=\\\"\\\" n=\\\"\\\" i=\\\"collaboration\\\"/></n><n m=\\\"0\\\" y=\\\"0\\\" x=\\\"0\\\" t=\\\"4\\\" d=\\\"\\\" n=\\\"end\\\" i=\\\"end\\\"><a a=\\\"\\\" b=\\\"\\\" c=\\\"1\\\" d=\\\"\\\" e=\\\"\\\" f=\\\"\\\" g=\\\"\\\" i=\\\"false\\\" j=\\\"false\\\" k=\\\"\\\"/><s c=\\\"1\\\" r=\\\"\\\" e=\\\"\\\" f=\\\"\\\" g=\\\"0\\\" j=\\\"multiple\\\" k=\\\"\\\" l=\\\"\\\" m=\\\"false\\\" s=\\\"success\\\" d=\\\"\\\" t=\\\"\\\" n=\\\"协同\\\" i=\\\"collaboration\\\"/></n><n a=\\\"1\\\" b=\\\"normal\\\" c=\\\"false\\\" l=\\\"1000\\\" e=\\\"0\\\" t=\\\"6\\\" d=\\\"\\\" n=\\\"t1\\\" i=\\\"14649370732230\\\"><a a=\\\"\\\" b=\\\"100000001\\\" c=\\\"1\\\" d=\\\"t1\\\" e=\\\"\\\" f=\\\"500000002\\\" h=\\\"false\\\" g=\\\"user\\\" i=\\\"false\\\" j=\\\"false\\\" k=\\\"roleadmin\\\"/><s c=\\\"1\\\" r=\\\"\\\" e=\\\"\\\" f=\\\"\\\" g=\\\"0\\\" j=\\\"all\\\" k=\\\"\\\" l=\\\"\\\" m=\\\"false\\\" s=\\\"success\\\" d=\\\"\\\" t=\\\"\\\" n=\\\"协同\\\" i=\\\"collaboration\\\"/></n><l a=\\\"\\\" b=\\\"\\\" c=\\\"\\\" e=\\\"\\\" m=\\\"\\\" h=\\\"3\\\" o=\\\"0\\\" j=\\\"14649370732230\\\" k=\\\"start\\\" t=\\\"11\\\" d=\\\"\\\" n=\\\"\\\" i=\\\"14649370732241\\\"/><l a=\\\"\\\" b=\\\"\\\" c=\\\"\\\" e=\\\"\\\" m=\\\"\\\" h=\\\"3\\\" o=\\\"0\\\" j=\\\"end\\\" k=\\\"14649370732230\\\" t=\\\"11\\\" d=\\\"\\\" n=\\\"\\\" i=\\\"14649370732242\\\"/></p></ps>\"," + 
    	 		"\"readyObjectJSON\":\"\"," + 
    	 		"\"workflow_data_flag\":\"WORKFLOW_SEEYON\"," + 
    	 		"\"process_info\":\"\"," + 
    	 		"\"process_info_selectvalue\":\"Member|500000002\"," + 
    	 		"\"process_subsetting\":\"\"," + 
    	 		"\"moduleType\":\"1\"," + 
    	 		"\"workflow_newflow_input\":\"\"," + 
    	 		"\"process_rulecontent\":\"\"," + 
    	 		"\"workflow_node_peoples_input\":\"\"," + 
    	 		"\"workflow_node_condition_input\":\"\"," + 
    	 		"\"processId\":\"\"," + 
    	 		"\"caseId\":\"-1\"," + 
    	 		"\"subObjectId\":\"-1\"," + 
    	 		"\"currentNodeId\":\"start\"," + 
    	 		"\"process_message_data\":\"\"," + 
    	 		"\"processChangeMessage\":\"\"," + 
    	 		"\"process_event\":\"\"" + 
    	 		"}," + 
    	 		"\"MainData\":{" + 
    	 		"\"data\":\"5287970320279180031_559993299593153025,\"," + 
    	 		"\"process_info\":\"t1(协同)\"," + 
    	 		"\"comment\":\"附言\\n\"," + 
    	 		"\"forwardOriginalNote\":\"1\"," + 
    	 		"\"forwardOriginalopinion\":\"1\"," + 
    	 		"\"track\":\"1\"" + 
    	 		"}," + 
    	 		"\"attachmentInputs\":[]" + 
    	 		"}" ;
    	 // 初始化Request和Response
        SeeyonTestRequest request = new SeeyonTestRequest();
        request.setParams(rParams);

        SeeyonTestResponse response = new SeeyonTestResponse(testResponseFile);

        // 设置session信息
        
        AppContext.putThreadContext(GlobalNames.THREAD_CONTEXT_REQUEST_KEY, request);
        
        String jsonStr = request.getParameter("_json_params");
        AppContext.putThreadContext(GlobalNames.THREAD_CONTEXT_JSONSTR_KEY, jsonStr);
        
        Map jsonObj = JSONUtil.parseJSONString(jsonStr, Map.class);
        AppContext.putThreadContext(GlobalNames.THREAD_CONTEXT_JSONOBJ_KEY, jsonObj);
        

       return response;
    }
    private static void saveTemplate() throws Exception {
    	
    	CtpTemplate template = templateManager.getCtpTemplate(templatesId5);
    	if (template == null) {
	    	CollaborationTemplateController controller = factory.generateController(CollaborationTemplateController.class);
	    	
	    	File responseFolder = new File(testResponseFolder);
	        if(!responseFolder.exists()){
	            responseFolder.mkdirs();
	        }
	        seeyon = orgManager.getMemberByLoginName("seeyon");
	    	
	        User user = SeeyonTestUtil.createSessionUser(seeyon);
	        AppContext.putThreadContext(GlobalNames.SESSION_CONTEXT_USERINFO_KEY, user);
	        
	        int key = 0;
	        long nodeId = SeeyonTestUtil.get14Id(key++);
	        
	        
	        /**
	         * 最基本的设置：标题（协同单元测试模版）；
	         * 流程节点：（谭敏锋(协同)-）；
	         * 正文：测试
	         * 授权：（当前部门200000001）；
	         * 模版id：templatesId5
	         */
	        String rParams = "_json_params={" + 
	        		"\"_currentDiv\":{" + 
	        		"\"_currentDiv\":\"0\"" + 
	        		"}," + 
	        		"\"mainbodyDataDiv_0\":{" + 
	        		"\"id\":\"\"," + 
	        		"\"createId\":\""+seeyon.getId()+"\"," + 
	        		"\"createDate\":\"\"," + 
	        		"\"modifyId\":\"\"," + 
	        		"\"modifyDate\":\"\"," + 
	        		"\"moduleType\":\"1\"," + 
	        		"\"moduleId\":\""+templatesId5+"\"," + 
	        		"\"contentType\":\"10\"," + 
	        		"\"moduleTemplateId\":\"-1\"," + 
	        		"\"contentTemplateId\":\"0\"," + 
	        		"\"sort\":\"0\"," + 
	        		"\"title\":\"[object Object]\"," + 
	        		"\"content\":\"<p>测试</p>\"," + 
	        		"\"rightId\":\"\"," + 
	        		"\"status\":\"STATUS_RESPONSE_NEW\"," + 
	        		"\"viewState\":\"1\"," + 
	        		"\"contentDataId\":\"\"" + 
	        		"}," + 
	        		"\"workflow_definition\":{" + 
	        		"\"process_desc_by\":\"xml\"," + 
	        		"\"process_xml\":\"<ps><p s=\\\"false\\\" u=\\\"\\\" y=\\\"0\\\" x=\\\"0\\\" t=\\\"p\\\" d=\\\"\\\" n=\\\"\\\" i=\\\"\\\"><n a=\\\"1\\\" b=\\\"normal\\\" c=\\\"false\\\" l=\\\"1000\\\" e=\\\"0\\\" f=\\\"\\\" g=\\\"\\\" h=\\\"\\\" y=\\\"70\\\" x=\\\"155\\\" t=\\\"6\\\" d=\\\"\\\" n=\\\"t1\\\" i=\\\"14649223791281\\\"><a a=\\\"\\\" b=\\\"100000001\\\" c=\\\"1\\\" d=\\\"t1\\\" e=\\\"个人\\\" f=\\\"500000002\\\" g=\\\"user\\\" h=\\\"false\\\" i=\\\"false\\\" j=\\\"false\\\" k=\\\"roleadmin\\\" /><s sa=\\\"0\\\" a=\\\"\\\" b=\\\"0\\\" c=\\\"1\\\" z=\\\"\\\" r=\\\"-1\\\" e=\\\"-1\\\" f=\\\"-1\\\" g=\\\"0\\\" na=\\\"-1\\\" w=\\\"-1\\\" rs=\\\"\\\" v=\\\"-1\\\" DR=\\\"\\\" sid=\\\"\\\" qid=\\\"\\\" h=\\\"-1\\\" u=\\\"-1\\\" tm=\\\"1\\\" j=\\\"single\\\" k=\\\"\\\" l=\\\"\\\" m=\\\"false\\\" s=\\\"success\\\" o=\\\"\\\" p=\\\"\\\" q=\\\"\\\" d=\\\"\\\" t=\\\"\\\" n=\\\"协同\\\" i=\\\"collaboration\\\" /></n><n f=\\\"\\\" g=\\\"\\\" h=\\\"\\\" y=\\\"70\\\" x=\\\"365\\\" t=\\\"4\\\" d=\\\"\\\" n=\\\"end\\\" i=\\\"end\\\"><a a=\\\"\\\" b=\\\"\\\" c=\\\"1\\\" d=\\\"\\\" e=\\\"\\\" f=\\\"\\\" g=\\\"\\\" h=\\\"false\\\" i=\\\"false\\\" j=\\\"false\\\" k=\\\"\\\" /><s sa=\\\"0\\\" a=\\\"\\\" b=\\\"0\\\" c=\\\"1\\\" z=\\\"\\\" r=\\\"-1\\\" e=\\\"-1\\\" f=\\\"-1\\\" g=\\\"0\\\" na=\\\"-1\\\" w=\\\"-1\\\" rs=\\\"\\\" v=\\\"-1\\\" DR=\\\"\\\" sid=\\\"\\\" qid=\\\"\\\" h=\\\"-1\\\" u=\\\"-1\\\" tm=\\\"1\\\" j=\\\"single\\\" k=\\\"\\\" l=\\\"\\\" m=\\\"false\\\" s=\\\"success\\\" o=\\\"\\\" p=\\\"\\\" q=\\\"\\\" d=\\\"\\\" t=\\\"\\\" n=\\\"协同\\\" i=\\\"collaboration\\\" /></n><n f=\\\"\\\" g=\\\"\\\" h=\\\"\\\" y=\\\"70\\\" x=\\\"50\\\" t=\\\"8\\\" d=\\\"\\\" n=\\\"发起者\\\" i=\\\"start\\\"><a a=\\\"\\\" b=\\\"\\\" c=\\\"1\\\" d=\\\"\\\" e=\\\"\\\" f=\\\"\\\" g=\\\"\\\" h=\\\"false\\\" i=\\\"false\\\" j=\\\"false\\\" k=\\\"\\\" /><s sa=\\\"0\\\" a=\\\"\\\" b=\\\"0\\\" c=\\\"1\\\" z=\\\"\\\" r=\\\"-1\\\" e=\\\"-1\\\" f=\\\"-1\\\" g=\\\"0\\\" na=\\\"-1\\\" w=\\\"-1\\\" v=\\\"-1\\\" DR=\\\"\\\" sid=\\\"\\\" qid=\\\"\\\" h=\\\"-1\\\" u=\\\"-1\\\" tm=\\\"1\\\" j=\\\"single\\\" k=\\\"\\\" l=\\\"\\\" m=\\\"false\\\" s=\\\"success\\\" o=\\\"\\\" p=\\\"\\\" q=\\\"\\\" d=\\\"\\\" t=\\\"\\\" n=\\\"协同\\\" i=\\\"collaboration\\\" /></n><n a=\\\"1\\\" b=\\\"normal\\\" c=\\\"false\\\" l=\\\"1000\\\" e=\\\"0\\\" f=\\\"\\\" g=\\\"\\\" h=\\\"\\\" y=\\\"70\\\" x=\\\"260\\\" t=\\\"6\\\" d=\\\"\\\" n=\\\"t1\\\" i=\\\"14649223873024\\\"><a a=\\\"\\\" b=\\\"100000001\\\" c=\\\"1\\\" d=\\\"t1\\\" e=\\\"个人\\\" f=\\\"500000002\\\" g=\\\"user\\\" h=\\\"false\\\" i=\\\"false\\\" j=\\\"false\\\" k=\\\"roleadmin\\\" /><s sa=\\\"0\\\" a=\\\"\\\" b=\\\"0\\\" c=\\\"1\\\" z=\\\"\\\" r=\\\"-1\\\" e=\\\"-1\\\" f=\\\"-1\\\" g=\\\"0\\\" na=\\\"-1\\\" w=\\\"-1\\\" rs=\\\"\\\" v=\\\"-1\\\" DR=\\\"\\\" sid=\\\"\\\" qid=\\\"\\\" h=\\\"-1\\\" u=\\\"-1\\\" tm=\\\"1\\\" j=\\\"single\\\" k=\\\"\\\" l=\\\"\\\" m=\\\"false\\\" s=\\\"success\\\" o=\\\"\\\" p=\\\"\\\" q=\\\"\\\" d=\\\"\\\" t=\\\"\\\" n=\\\"协同\\\" i=\\\"collaboration\\\" /></n><l a=\\\"\\\" b=\\\"\\\" c=\\\"\\\" m=\\\"\\\" e=\\\"\\\" h=\\\"3\\\" o=\\\"0\\\" j=\\\"end\\\" k=\\\"14649223873024\\\" t=\\\"11\\\" d=\\\"\\\" n=\\\"\\\" i=\\\"14649223708980\\\" /><l a=\\\"\\\" b=\\\"\\\" c=\\\"\\\" m=\\\"\\\" e=\\\"\\\" h=\\\"3\\\" o=\\\"0\\\" j=\\\"14649223873024\\\" k=\\\"14649223791281\\\" t=\\\"11\\\" d=\\\"\\\" n=\\\"\\\" i=\\\"14649223873035\\\" /><l a=\\\"\\\" b=\\\"\\\" c=\\\"\\\" m=\\\"\\\" e=\\\"\\\" h=\\\"3\\\" o=\\\"0\\\" j=\\\"14649223791281\\\" k=\\\"start\\\" t=\\\"11\\\" d=\\\"\\\" n=\\\"\\\" i=\\\"14649223791292\\\" /></p></ps>\"," + 
	        		"\"readyObjectJSON\":\"\"," + 
	        		"\"workflow_data_flag\":\"WORKFLOW_SEEYON\"," + 
	        		"\"process_info\":\"\"," + 
	        		"\"process_info_selectvalue\":\"\"," + 
	        		"\"process_subsetting\":\"{}\"," + 
	        		"\"moduleType\":\"1\"," + 
	        		"\"workflow_newflow_input\":\"\"," + 
	        		"\"process_rulecontent\":\"\"," + 
	        		"\"workflow_node_peoples_input\":\"\"," + 
	        		"\"workflow_node_condition_input\":\"\"," + 
	        		"\"processId\":\"-1\"," + 
	        		"\"caseId\":\"-1\"," + 
	        		"\"subObjectId\":\"-1\"," + 
	        		"\"currentNodeId\":\"-1\"," + 
	        		"\"process_message_data\":\"\"," + 
	        		"\"processChangeMessage\":\"\"," + 
	        		"\"process_event\":\"{}\"" + 
	        		"}," + 
	        		"\"advanceHTML\":{" + 
	        		"\"deadline\":\"0\"," + 
	        		"\"referenceTime\":\"0\"," + 
	        		"\"advanceRemind\":\"0\"," + 
	        		"\"canTrackWorkFlow\":\"0\"," + 
	        		"\"canForward\":\"1\"," + 
	        		"\"canModify\":\"1\"," + 
	        		"\"canEdit\":\"1\"," + 
	        		"\"canEditAttachment\":\"1\"," + 
	        		"\"canArchive\":\"1\"," + 
	        		"\"canAutoStopFlow\":null," + 
	        		"\"canMergeDeal\":null," + 
	        		"\"canAnyMerge\":null," + 
	        		"\"templeteNumber\":\"\"," + 
	        		"\"templeteId4Number\":\"\"" + 
	        		"}," + 
	        		"\"templateMainData\":{" + 
	        		"\"newBusiness\":\"1\"," + 
	        		"\"id\":\""+templatesId5+"\"," + 
	        		"\"from\":\"\"," + 
	        		"\"categoryType\":\"1\"," + 
	        		"\"authInfo\":\"Department|200000001\"," + 
	        		"\"archiveId\":\"\"," + 
	        		"\"prevArchiveId\":\"\"," + 
	        		"\"process_info_bak\":\"\"," + 
	        		"\"process_xml_bak\":\"\"," + 
	        		"\"subject\":\"协同单元测试模版\"," + 
	        		"\"type\":\"template\"," + 
	        		"\"categoryId\":\"-3723196610055682131\"," + 
	        		"\"process_info\":\"谭敏锋(协同)、谭敏锋(协同)\"," + 
	        		"\"importantLevel\":\"1\"," + 
	        		"\"colPigeonhole\":\"1\"," + 
	        		"\"projectId\":\"\"" + 
	        		"}," + 
	        		"\"comment_deal\":{" + 
	        		"\"id\":\"\"," + 
	        		"\"pid\":\"0\"," + 
	        		"\"clevel\":\"1\"," + 
	        		"\"path\":\"00\"," + 
	        		"\"moduleType\":\"1\"," + 
	        		"\"moduleId\":\"-1\"," + 
	        		"\"extAtt1\":\"\"," + 
	        		"\"ctype\":\"-1\"," + 
	        		"\"content_coll\":\"\"" + 
	        		"}," + 
	        		"\"superviseDiv\":{" + 
	        		"\"detailId\":\"\"," + 
	        		"\"supervisorIds\":\"\"," + 
	        		"\"supervisorNames\":\"\"," + 
	        		"\"awakeDate\":\"\"," + 
	        		"\"title\":\"\"," + 
	        		"\"unCancelledVisor\":\"\"," + 
	        		"\"role\":\"\"," + 
	        		"\"templateDateTerminal\":\"\"," + 
	        		"\"superviseType\":\"\"," + 
	        		"\"moduleId\":\"\"," + 
	        		"\"description\":\"\"," + 
	        		"\"isModifySupervise\":\"0\"," + 
	        		"\"hasLoad\":\"0\"" + 
	        		"}," + 
	        		"\"attachmentInputs\":[]" + 
	        		"}";
	         // 初始化Request和Response
	         SeeyonTestRequest request = new SeeyonTestRequest();
	         request.setParams(rParams);
	
	         SeeyonTestResponse response = new SeeyonTestResponse(testResponseFile);
	
	         // 设置session信息
	         AppContext.putThreadContext(GlobalNames.THREAD_CONTEXT_REQUEST_KEY, request);
	         
	         String jsonStr = request.getParameter("_json_params");
	         AppContext.putThreadContext(GlobalNames.THREAD_CONTEXT_JSONSTR_KEY, jsonStr);
	
	
	        // 调用Contraller
	        controller.saveCollaborationTemplate(request, response);
	
	        // 数据销毁
	        AppContext.removeThreadContext(GlobalNames.THREAD_CONTEXT_REQUEST_KEY);
	        SeeyonTestUtil.closeResponseIO(response);
    	}
    }
    
}