/**
 * Author : xuqw
 *   Date : 2015年9月24日 下午8:25:18
 *
 * Copyright (C) 2015 Seeyon, Inc. All rights reserved.
 *
 * This software is the proprietary information of Seeyon, Inc.
 * Use is subject to license terms.
 */
package com.seeyon.apps.http;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;

import javax.servlet.AsyncContext;
import javax.servlet.DispatcherType;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpUpgradeHandler;
import javax.servlet.http.Part;

/**
 * <p>Title       : 应用模块名称</p>
 * <p>Description : 代码描述</p>
 * <p>Copyright   : Copyright (c) 2015</p>
 * <p>Company     : seeyon.com</p>
 */
public class SeeyonTestRequest implements HttpServletRequest {

    
    private String[][] params = null;
    private Map<String, Object> attrs = new HashMap<String, Object>();
    
    public void setParams(String paramsStr){
        
        if(paramsStr != null){
            String newString = paramsStr.trim();
            String[] items = newString.split("&");
            params = new String[items.length][2];
            for(int i = 0; i < items.length; i++){
                String item = items[i];
                int index = item.indexOf("=");
                if(index != -1){
                    params[i][0] = item.substring(0,index);
                    params[i][1] = item.substring(index + 1);
                }else{
                    params[i][0] = item;
                    params[i][1] = "";
                }
            }
        }
    }
    
    
    @Override
    public Object getAttribute(String name) {
        return attrs.get(name);
    }

    @Override
    public Enumeration getAttributeNames() {
        
        String[] keys = new String[attrs.size()];
        Set<String> attKeys = attrs.keySet();
        Iterator<String> iKeys = attKeys.iterator();
        int index = 0;
        while (iKeys.hasNext()) {
            keys[index] = iKeys.next();
            index++;
        }
        StringEnumeration se = new StringEnumeration(keys);
        
        return se;
    }

    @Override
    public String getCharacterEncoding() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public void setCharacterEncoding(String env)
            throws UnsupportedEncodingException {
        // TODO Auto-generated method stub
        
    }

    @Override
    public int getContentLength() {
        // TODO Auto-generated method stub
        return 0;
        
    }

    @Override
    public String getContentType() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public ServletInputStream getInputStream() throws IOException {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getParameter(String name) {
        if(name != null){
            for(int i = 0; i < params.length; i++){
                String[] item = params[i];
                if(name.equals(item[0])){
                    return item[1];
                }
            }
        }
        return null;
    }

    @Override
    public Enumeration getParameterNames() {
        
        String[] keys = new String[params.length];
        for(int i = 0; i < params.length; i++){
            keys[i] = params[i][0];
        }
        StringEnumeration se = new StringEnumeration(keys);
        return se;
    }

    @Override
    public String[] getParameterValues(String name) {
       
        List<String> retList = new ArrayList<String>();
        if(name != null){
            for(int i = 0; i < params.length; i++){
                String[] item = params[i];
                if(name.equals(item[0])){
                    retList.add(item[1]);
                }
            }
        }
        String[] ret = new String[retList.size()];
        return retList.toArray(ret);
    }

    @Override
    public Map getParameterMap() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getProtocol() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getScheme() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getServerName() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public int getServerPort() {
        // TODO Auto-generated method stub
        return 0;
        
    }

    @Override
    public BufferedReader getReader() throws IOException {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getRemoteAddr() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getRemoteHost() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public void setAttribute(String name, Object o) {
        attrs.put(name, o);
    }

    @Override
    public void removeAttribute(String name) {
        attrs.remove(name);
    }

    @Override
    public Locale getLocale() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Enumeration getLocales() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public boolean isSecure() {
        // TODO Auto-generated method stub
        return false;
        
    }

    @Override
    public RequestDispatcher getRequestDispatcher(String path) {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getRealPath(String path) {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public int getRemotePort() {
        // TODO Auto-generated method stub
        return 0;
        
    }

    @Override
    public String getLocalName() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getLocalAddr() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public int getLocalPort() {
        // TODO Auto-generated method stub
        return 0;
        
    }

    @Override
    public String getAuthType() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public Cookie[] getCookies() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public long getDateHeader(String name) {
        // TODO Auto-generated method stub
        return 0;
        
    }

    @Override
    public String getHeader(String name) {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public Enumeration getHeaders(String name) {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public Enumeration getHeaderNames() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public int getIntHeader(String name) {
        // TODO Auto-generated method stub
        return 0;
        
    }

    @Override
    public String getMethod() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getPathInfo() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getPathTranslated() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getContextPath() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getQueryString() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getRemoteUser() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public boolean isUserInRole(String role) {
        // TODO Auto-generated method stub
        return false;
        
    }

    @Override
    public Principal getUserPrincipal() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getRequestedSessionId() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getRequestURI() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public StringBuffer getRequestURL() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public String getServletPath() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public HttpSession getSession(boolean create) {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public HttpSession getSession() {
        // TODO Auto-generated method stub
        return null;
        
    }

    @Override
    public boolean isRequestedSessionIdValid() {
        // TODO Auto-generated method stub
        return false;
        
    }

    @Override
    public boolean isRequestedSessionIdFromCookie() {
        // TODO Auto-generated method stub
        return false;
        
    }

    @Override
    public boolean isRequestedSessionIdFromURL() {
        // TODO Auto-generated method stub
        return false;
        
    }

    @Override
    public boolean isRequestedSessionIdFromUrl() {
        // TODO Auto-generated method stub
        return false;
        
    }


	@Override
	public AsyncContext getAsyncContext() {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public long getContentLengthLong() {
		// TODO Auto-generated method stub
		return 0;
	}


	@Override
	public DispatcherType getDispatcherType() {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public ServletContext getServletContext() {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public boolean isAsyncStarted() {
		// TODO Auto-generated method stub
		return false;
	}


	@Override
	public boolean isAsyncSupported() {
		// TODO Auto-generated method stub
		return false;
	}


	@Override
	public AsyncContext startAsync() throws IllegalStateException {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public AsyncContext startAsync(ServletRequest arg0, ServletResponse arg1) throws IllegalStateException {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public boolean authenticate(HttpServletResponse arg0) throws IOException, ServletException {
		// TODO Auto-generated method stub
		return false;
	}


	@Override
	public String changeSessionId() {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public Part getPart(String arg0) throws IOException, ServletException {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public Collection<Part> getParts() throws IOException, ServletException {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public void login(String arg0, String arg1) throws ServletException {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void logout() throws ServletException {
		// TODO Auto-generated method stub
		
	}


	@Override
	public <T extends HttpUpgradeHandler> T upgrade(Class<T> arg0) throws IOException, ServletException {
		// TODO Auto-generated method stub
		return null;
	}

}
