/**
 * Author : xuqw
 *   Date : 2015年9月25日 下午3:25:04
 *
 * Copyright (C) 2015 Seeyon, Inc. All rights reserved.
 *
 * This software is the proprietary information of Seeyon, Inc.
 * Use is subject to license terms.
 */
package com.seeyon.apps.http;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;


/**
 * <p>
 * Title : 应用模块名称
 * </p>
 * <p>
 * Description : 代码描述
 * </p>
 * <p>
 * Copyright : Copyright (c) 2015
 * </p>
 * <p>
 * Company : seeyon.com
 * </p>
 */
public class StringEnumeration implements Enumeration<String> {

    private List<String> keys = new ArrayList<String>();
    private int index = 0;//索引位置
    private int size = 0;//总共的数量

    /**
     * 数组方式初始化
     * @param strs
     */
    public StringEnumeration(String[] strs){
        if(strs != null){
            Collections.addAll(keys, strs);
            size = keys.size();
        }
    }
    
    public StringEnumeration(List<String> strs){
        if(strs != null){
            keys.addAll(strs);
            size = keys.size();
        }
    }
    
    @Override
    public boolean hasMoreElements() {
        return index < size;
    }

    @Override
    public String nextElement() {
        String ret = keys.get(index);
        index++;
        return ret;
    }
    
    /*public static void main(String[] args) {
        String[] keys = {"key1", "ket2", "ket3", "ket4"};
        StringEnumeration se = new StringEnumeration(keys);
        while (se.hasMoreElements()) {
            String key = se.nextElement();
            System.out.println(key);
        }
    }*/
}
